#include "output.h"
#include <Arduino.h>
#include <U8g2lib.h>
#include <Wire.h>
#include <DueTimer.h>
#include "pins.h"
#include "logger.h"

U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);

#define u8g_logo_width 128
#define u8g_logo_height 64
static const uint8_t u8g_logo_bits[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x00, 0x00, 
  0xFE, 0xFF, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 
  0xF0, 0xFF, 0x00, 0x00, 0xFF, 0xFF, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 
  0x00, 0x00, 0x00, 0x00, 0xF0, 0xFF, 0x00, 0x00, 0xFF, 0x7F, 0xFC, 0x7F, 
  0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xFF, 0x00, 0x80, 
  0xFF, 0x7F, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 
  0xF0, 0xFF, 0x00, 0xC0, 0xFF, 0x3F, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 
  0x00, 0x00, 0x00, 0x1C, 0xE0, 0xFF, 0x00, 0xE0, 0xFF, 0x1F, 0xFC, 0x7F, 
  0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x1F, 0xE0, 0xFF, 0x00, 0xF0, 
  0xFF, 0x0F, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xC0, 0x3F, 
  0xE0, 0xFF, 0x00, 0xF8, 0xFF, 0x07, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 
  0x00, 0x00, 0xE0, 0x3F, 0xE0, 0xFF, 0x00, 0xFC, 0xFF, 0x07, 0xFC, 0x7F, 
  0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xF8, 0x7F, 0xC0, 0xFF, 0x00, 0xFE, 
  0xFF, 0x03, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFC, 0x7F, 
  0xC0, 0xFF, 0x00, 0xFF, 0xFF, 0x01, 0xFC, 0x7F, 0xFE, 0xFF, 0xFF, 0xFF, 
  0x00, 0x00, 0xF8, 0xFF, 0xC0, 0xFF, 0x80, 0xFF, 0xFF, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0xF8, 0xFF, 0xC0, 0xFF, 0xC0, 0xFF, 
  0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0xF0, 0xFF, 
  0x81, 0xFF, 0xC0, 0xFF, 0x3F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x00, 0x00, 0xE0, 0xFF, 0x81, 0xFF, 0xE0, 0xFF, 0x3F, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0xC0, 0xFF, 0x83, 0xFF, 0xF0, 0xFF, 
  0x1F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0x80, 0xFF, 
  0x83, 0xFF, 0xF8, 0xFF, 0x0F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x00, 0x18, 0x00, 0xFF, 0x03, 0xFF, 0xFC, 0xFF, 0x07, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0x3C, 0x00, 0xFF, 0x07, 0xFF, 0xFC, 0xFF, 
  0x03, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0xFC, 0x00, 0xFE, 
  0x07, 0xFF, 0xFC, 0xFF, 0x03, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x00, 0xFE, 0x01, 0xFC, 0x0F, 0xFF, 0xFC, 0xFF, 0x01, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0xFF, 0x03, 0xF8, 0x0F, 0xFE, 0xFC, 0xFF, 
  0x00, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0xFF, 0x07, 0xF0, 
  0x1F, 0xFE, 0xFC, 0x7F, 0x00, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x80, 0xFF, 0x1F, 0xF0, 0x1F, 0xFE, 0xFC, 0x7F, 0x00, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x80, 0xFF, 0x3F, 0xE0, 0x3F, 0xFE, 0xFC, 0xFF, 
  0x00, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xC0, 0xFF, 0x7F, 0xC0, 
  0x3F, 0xFC, 0xFC, 0xFF, 0x01, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0xC0, 0xFF, 0xFF, 0x80, 0x7F, 0xFC, 0xFC, 0xFF, 0x01, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x80, 0xFF, 0xFF, 0x03, 0x7F, 0xFC, 0xFC, 0xFF, 
  0x03, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0xFE, 0xFF, 0x07, 
  0xFE, 0xFC, 0xFC, 0xFF, 0x07, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x00, 0xF0, 0xFF, 0x0F, 0xFE, 0xF8, 0xF8, 0xFF, 0x0F, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0xC0, 0xFF, 0x1F, 0xFC, 0xF9, 0xF0, 0xFF, 
  0x1F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0xFF, 0x7F, 
  0xF8, 0xF9, 0xE0, 0xFF, 0x1F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0x00, 0x00, 0xFC, 0xFF, 0xF0, 0xFB, 0xE0, 0xFF, 0x3F, 0x00, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0xF0, 0xFF, 0xE1, 0xF3, 0xC0, 0xFF, 
  0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x18, 0x00, 0xC0, 0xFF, 
  0xC3, 0xF3, 0x80, 0xFF, 0xFF, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0xF8, 0x01, 0x00, 0xFE, 0xCF, 0xF7, 0x00, 0xFF, 0xFF, 0x01, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0xFC, 0x1F, 0x00, 0xF8, 0x9F, 0xF7, 0x00, 0xFE, 
  0xFF, 0x03, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0xFF, 0x01, 0xE0, 
  0x3F, 0xEF, 0x00, 0xFC, 0xFF, 0x03, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0xFC, 0xFF, 0x1F, 0x80, 0x7F, 0xFE, 0x00, 0xF8, 0xFF, 0x07, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0xFC, 0xFF, 0xFF, 0x01, 0xFE, 0xFD, 0x00, 0xF0, 
  0xFF, 0x0F, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xFC, 0xFF, 0xFF, 0x1F, 
  0xF8, 0xFF, 0x00, 0xE0, 0xFF, 0x1F, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0xFC, 0xFF, 0xFF, 0xFF, 0xC1, 0xFF, 0x00, 0xC0, 0xFF, 0x3F, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 0x1F, 0xFF, 0x00, 0x80, 
  0xFF, 0x3F, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 
  0xFF, 0xFD, 0x00, 0x00, 0xFF, 0x7F, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 
  0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFE, 0xFF, 0xFC, 0x7F, 
  0x00, 0xFC, 0x7F, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0x3F, 0x00, 0x00, 
  0xFC, 0xFF, 0xFC, 0x7F, 0x00, 0xFC, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, };

void timerTickFlash();

static int test_no = 1;
static int bpm_start = 0;
static int bpm_stop = 0;
static int ptt_start = 0;
static int ptt_stop = 0;
static int duration = 0;

static bool flash_show = true;

void Output::initialize() {
  // Initialize display
  u8g2.begin();
  u8g2.setDrawColor(1);

  // Draw logo for 2 seconds
  u8g2.clearBuffer();
  u8g2.drawXBM(0, 0, u8g_logo_width, u8g_logo_height, u8g_logo_bits);
  u8g2.sendBuffer();
  delay(2000);
  
  Timer7.attachInterrupt(timerTickFlash).setPeriod(500*1000);
}

void Output::display_test(int _test_no, int _duration, int _bpm_start, int _bpm_stop, int _ptt_start, int _ptt_stop, bool isRunning) {
  Timer7.stop();
  
  test_no = _test_no;
  bpm_start = _bpm_start;
  bpm_stop = _bpm_stop;
  ptt_start = _ptt_start;
  ptt_stop = _ptt_stop;
  duration = _duration;
  flash_show = true;
  if(!isRunning) {
    Timer7.start();
  }

  draw_display();
}

void Output::clear_display() {
  Timer7.stop();
  u8g2.clearBuffer();
}

void timerTickFlash() {
  flash_show = !flash_show;
}

void Output::draw_display() {
  u8g2.clearBuffer();

  u8g2.setFont(u8g2_font_6x10_tf);
  u8g2.setFontRefHeightExtendedText();
  u8g2.setFontPosTop();
  u8g2.setFontDirection(0);

  const int w2 = 64; // Half width
  char str[20];
  
  // Draw outside rect
  u8g2.drawFrame(0, 0, 128, 64);
  // Draw values
  if(bpm_start == bpm_stop) {
    u8g2.setFont(u8g2_font_crox4hb_tf); // 15px font
    sprintf(str,"%03d", bpm_start);
    u8g2.drawStr(17, 7, str);
  } else {
    u8g2.setFont(u8g2_font_crox2hb_tf); // 10px font
    sprintf(str,"%03d-%03d", bpm_start, bpm_stop);
    u8g2.drawStr(8, 9, str);    
  }
  if(ptt_start == ptt_stop) {
    u8g2.setFont(u8g2_font_crox4hb_tf); // 15px font
    sprintf(str,"%03d", ptt_start);
    u8g2.drawStr(w2 + 13, 7, str);
  } else {
    u8g2.setFont(u8g2_font_crox2hb_tf); // 10px font
    sprintf(str,"%03d-%03d", ptt_start, ptt_stop);
    u8g2.drawStr(w2 + 4, 9, str);    
  }
  // Draw caption
  u8g2.setFont(u8g2_font_crox1hb_tf); // 9px font
  u8g2.drawStr(21, 27, "bpm");
  u8g2.drawStr(w2 + 22, 27, "ms");  
  // Draw horizontal delimiter
  u8g2.drawHLine(0, 45, 2*w2);
  // Draw footer
  u8g2.setFont(u8g2_font_crox2hb_tf); // 10px font
  sprintf(str,"Test %02d", test_no);
  u8g2.drawStr(7, 48, str);
  if(flash_show) {
    int minutes = duration / 60;
    int seconds = duration % 60;
    sprintf(str,"%02d:%02d", minutes, seconds);
    u8g2.drawStr(w2 + 17, 48, str);
  }

  u8g2.sendBuffer();
}

